
import {
    CanActivate,
    ActivatedRouteSnapshot,
    RouterStateSnapshot,
    Router,
  } from "@angular/router";
  import { Injectable } from "@angular/core";
  import { AuthService } from "./auth.service";
  import { HttpClient, HttpHeaders, HttpClientModule } from '@angular/common/http';

  
  @Injectable()
  export class LoggedInGuard implements CanActivate {
    user
    constructor(private router: Router, private AuthService: AuthService, private http: HttpClient) {}
    
    canActivate(route: ActivatedRouteSnapshot, state: RouterStateSnapshot): Promise<boolean>  {
      return new Promise((resolve) => {
        // is not, pull profile
        this.http.get('/api/v1/user/profile')
                .subscribe((user : any) => {
                    console.log('User is authenticated, redirect to index')
                    this.router.navigate(['/'])
                    resolve(false)
                }, error => {
                    // all unknown errors redirect to login, typical for user does not exist in db etc
                    console.log("User is not authenticated, stay.")
                    resolve(true)
                  });
      
      })
    }
  } 


