const fileClass = require('./fileclass')
const math = require('math')
const fs = require('fs')
const fsPromises = require('fs').promises

// this class wil check every minute if there are any new files in selfupload folder
class selfupload {
  constructor() {
    this.limit = 60000

    this.timerObj = setInterval(this.checkfiles.bind(this), this.limit)

    if (!fs.existsSync(process.env.selfupload)) {
      fs.mkdir(process.env.selfupload, { recursive: true }, (err) => {
        //WINSTON ERROR
      })
    }
  }

  async listFiles() {
    return fsPromises.readdir(process.env.selfupload)
  }

  async checkfiles() {
    console.log('checking selfupload folder')
    let files = await this.listFiles()
    console.log(files)
    if (files) {
        new fileClass(
          process.env.selfupload,
          files)
    }
  }
}

module.exports = new selfupload()
