import { Component } from '@angular/core';
import { AuthService } from './auth/auth.service';
import { Subscription } from "rxjs";


@Component({
  selector: 'app-root',
  templateUrl: './app.component.html', 
  styleUrls: ['./app.component.scss']
})
export class AppComponent {
  userIsAuthenticated = false
  private authListnerSubs: Subscription
  private collapsed: boolean

  constructor(private authService: AuthService) {
    //this.authService.checkTokenValidation().subscribe();
  }
  title = 'frontend';
  user

  ngOnInit(){
  // listen to auth changes
  this.authListnerSubs = this.authService.getAuthStatusListener()
      .subscribe(isAuthenticated => {
          this.userIsAuthenticated = isAuthenticated  //Authorizes user
      }) 
  }
}