import { Component, OnInit } from '@angular/core'
import { Router, ActivatedRoute, Params } from '@angular/router'
import { AuthService } from 'src/app/auth/auth.service'

@Component({
    selector: 'app-notactive',
    templateUrl: './notactive.component.html',
    styleUrls: ['./notactive.component.scss']
  })

export class notactiveComponent implements OnInit {
  
    constructor(private route: ActivatedRoute, private AuthService: AuthService) {}
  
    ngOnInit() {
      
    }

    onLogout() { //Adds logout functionality, linked to a auth.service.js signout()
        this.AuthService.signout()
    }
  }