class User {
	constructor(data) {
		this.data = data
	}
	serialize() {
		var x = {
			"data": this.data
		}

		if (this.token) {
			x.token = this.token
		}
		if (this.idtoken) {
			x.idtoken = this.idtoken
		}
		if (this.groups) {
			x.groups = this.groups
		}
		return x
	}
	static unserialize(obj) {
		var u = new User(obj.data)
		if (obj.token) {
			u.token = obj.token
		}
		if (obj.idtoken) {
			u.idtoken = obj.idtoken
		}
		if (obj.groups) {
			u.groups = obj.groups
		}
		if(obj.db){
			u.db = obj.db
		}
		return u
	}
}

exports.User = User;
